<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


jimport('joomla.html.html');
jimport('joomla.form.formfield');//import the necessary class definition for formfield


/**
 * Supports an HTML select list of articles
 * @since  1.6
 */
class JFormFieldConverterMeasures extends JFormField
{
	/**
  * The form field type.
  *
  * @var  string
  * @since	1.6
  */
	protected $type = 'ConverterMeasures'; //the form field type

	/**
  * Method to get content articles
  *
  * @return	array	The field option objects.
  * @since	1.6
  */
	protected function getInput()
	{

    $this->includeJsAndCss();

    ob_start();

      $data = $this->getMeasures();

      ?>
      <div class="measureConverterOptions">
          <ul>
              <?php foreach($data as $measureName => $measure):?>

                  <li class="measureNode" data-measure-name="<?php echo $measureName?>">

                      <div>
                          <label>
                              <input type="checkbox" class="root" <?php if($measure['active']) echo 'checked="checked"';?>>
                              <?php echo $measureName?>
                          </label>
                          <a href="#delete" class="deleteGroup" data-unit-group="<?php echo $measureName?>">delete</a>
                      </div>

                      <ul <?php if(!$measure['active']) echo 'style="display:none;"'?>>
                          <?php foreach($measure['units'] as $unitName => $unit):?>
                              <li>
                                  <label>
                                      <input type="checkbox" class="unit"
                                             data-unit="<?php echo $unitName?>"
                                             data-unit-data='{"scale":<?php echo $unit["scale"] ?>,"shift":<?php echo isset($unit["shift"]) ? $unit["shift"] : 0 ?>}'
                                          <?php if($unit['active']) echo 'checked="checked"';?>> <?php echo $unitName?>
                                  </label>
                                  <a href="#delete" class="deleteUnit" data-unit='{"name":"<?php echo $unitName?>", "group":"<?php echo $measureName?>"}'><?php echo('delete'); ?></a>
                              </li>
                          <?php endforeach;?>
                          <li class="addCustomUnit">
                              <p style="display:none;">Specify the name of new unit and the count of
                                  <b><?php echo key($measure['units']) ?></b> (s) in your custom unit
                              </p>
                              <a href="#add" class="addCustomUnitBtn">+ Add custom</a>
                          </li>
                      </ul>

                  </li>
              <?php endforeach; ?>
              <li class="addCustomGroup">
                  <p style="display:none;"><?php echo('Specify the name of new group and the main unit. All other units should be set depends on main unit.'); ?></p>
                  <a href="#add" class="addCustomGroupBtn">+ Add custom group</a>
              </li>
          </ul>
      </div>
  <?php

    $content = ob_get_contents();
    ob_end_clean();
    return '<input type="hidden" name="'.$this->name.'" value="'.$this->value.'" id="measurementConverterData"/>' .$content;

  }

  function includeJsAndCss(){

    JHtml::stylesheet(JURI::root().'modules/mod_measure_converter/css/converter_styles.css');
    JHtml::script('https://ajax.googleapis.com/ajax/libs/jquery/1.6.2/jquery.min.js');
    JHtml::script(JURI::root().'modules/mod_measure_converter/js/measure-converter-admin.js');
    
  }

  function getMeasures(){
    return json_decode(str_replace("'",'"',$this->value), true);
  }

  
}

