jQuery(function($){

    // Admin area:

    var $optionsDiv = $('.measureConverterOptions');

    function serialiseData(){

        var Data = {};

        $optionsDiv.find('.measureNode').each(function (i,el){

            var measureNode = $(el),
                  measureName,
                  status;

            measureName = measureNode.data('measure-name');
            status = measureNode.find('input.root').is(':checked');

            Data[measureName] = {};
            Data[measureName].units = {};
            Data[measureName].active = status;

            measureNode.find('ul input.unit').each(function (i, el){

                var $el = $(el), name, unitData;

                name = $el.data('unit');
                unitData = $el.data('unit-data');
                unitData.active = $el.is(':checked');

                Data[measureName].units[name] = unitData;

            });
        });

        $('#measurementConverterData').val(JSON.stringify(Data).replace(/"/g,"'"));

    }


    $optionsDiv.delegate('input','change',function (){
        serialiseData();
    });


    $optionsDiv.find('.root').live('change',function(){

        var $this = $(this);

        if($this.is(':checked')){
            $this.closest('li').find('ul').slideDown(200);
        } else {
            $this.closest('li').find('ul').slideUp(200);
        }

    });


    $optionsDiv.find('.addCustomUnit .addCustomUnitBtn').live('click', function(e){

        var $this = $(this);
        $this.siblings('p').show();

        var measureName = $this.closest('.measureNode').data('measure-name');
        var index = $this.closest('.measureNode').find('.addCustomUnit').length - 1;

        var insert = '<label>Name: <input type="text" class="name"></label></br>' +
                     '<label>Value: <input type="text" class="value"></label>' +
                     '<a href="#" class="addUnit button">Ok</a>';

        $this.parent().after($this.parent().clone());
        $this.parent().html(insert);

        e.preventDefault();
    });


    $optionsDiv.find('.addCustomUnit .addUnit').live('click', function(e){
        e.preventDefault();

        var parent = $(this).parent(),
              insert = '', unitName;

        unitName = parent.find('.name').val();
        unitVal = parent.find('.value').val();

        if(!unitName || !unitVal || !isNumber(unitVal)){
            return;
        }

        insert = '<li><label><input type="checkbox" class="unit" data-unit="'+ unitName +'" ' +
                 'data-unit-data=\'{"scale":'+ unitVal +',"shift":0}\'' +
                 'checked="checked" /> '+ unitName +'</label>' +
                 '<a href="#delete" class="deleteUnit">delete</a></li>';

        parent.before(insert).remove();
        $optionsDiv.find('.addCustomUnit p').hide();
        serialiseData();
    });


    $optionsDiv.find('.addCustomGroup .addCustomGroupBtn').live('click', function(e){

        var $this = $(this);
        $this.siblings('p').show();

        var insert = '<label><span class="eqwidth">Group Name:</span><input class="groupName" type="text"></label></br>' +
                     '<label><span class="eqwidth">Main unit: </span><input class="unitName" type="text"></label>' +
                     '<a href="#" class="addGroup button">Ok</a>';

        $this.parent().after($this.parent().clone());
        $this.parent().html(insert);

        e.preventDefault();
    });


    $optionsDiv.find('.addCustomGroup .addGroup').live('click', function(e){
        e.preventDefault();

        var parent = $(this).parent(),
              insert = '', measureName, unitName;

        measureName = parent.find('.groupName').val();
        unitName = parent.find('.unitName').val();

        if(!measureName || !unitName){
            return;
        }

        insert = '<li data-measure-name="'+ measureName +'" class="measureNode"><div><label>' +
                 '<input type="checkbox" checked="checked" class="root">'+ measureName +'</label>' +
                 '<a class="deleteGroup" href="#delete">delete</a></div><ul><li><label>' +
                 '<input type="checkbox" checked="checked" data-unit-data=\'{"scale":1,"shift":0}\' ' +
                 'data-unit="'+ unitName +'" class="unit">'+ unitName +'</label>' +
                 '<a class="deleteUnit" href="#delete">delete</a></li></ul></li>';

        parent.before(insert).remove();
        $optionsDiv.find('.addCustomGroup p').hide();
        serialiseData();
    });


    $optionsDiv.find('.deleteUnit').live('click', function(e){
        $(this).parent().remove();
        serialiseData();
        e.preventDefault();
    });

    $optionsDiv.find('.deleteGroup').live('click', function(e){

        var $this = $(this);

        var confirmed = confirm("Are you sure you want to delete group? All items in the group will be deleted.");

        if(confirmed){
            $this.closest('.measureNode').remove();
            serialiseData();
        }

        e.preventDefault();
    });


});


// implement JSON.stringify serialization
JSON.stringify = JSON.stringify || function (obj) {
    var t = typeof (obj);
    if (t != "object" || obj === null) {
        // simple data type
        if (t == "string") obj = '"'+obj+'"';
        return String(obj);
    }
    else {
        // recurse array or object
        var n, v, json = [], arr = (obj && obj.constructor == Array);
        for (n in obj) {
            v = obj[n]; t = typeof(v);
            if (t == "string") v = '"'+v+'"';
            else if (t == "object" && v !== null) v = JSON.stringify(v);
            json.push((arr ? "" : '"' + n + '":') + String(v));
        }
        return (arr ? "[" : "{") + String(json) + (arr ? "]" : "}");
    }
};


function isNumber(n) {
  return !isNaN(parseFloat(n)) && isFinite(n);
}